package org.apache.cayenne.testdo.table_primitives.auto;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.apache.cayenne.PersistentObject;
import org.apache.cayenne.exp.property.BaseProperty;
import org.apache.cayenne.exp.property.NumericIdProperty;
import org.apache.cayenne.exp.property.NumericProperty;
import org.apache.cayenne.exp.property.PropertyFactory;
import org.apache.cayenne.exp.property.SelfProperty;
import org.apache.cayenne.testdo.table_primitives.TablePrimitives;

/**
 * Class _TablePrimitives was generated by Cayenne.
 * It is probably a good idea to avoid changing this class manually,
 * since it may be overwritten next time code is regenerated.
 * If you need to make any customizations, please use subclass.
 */
public abstract class _TablePrimitives extends PersistentObject {

    private static final long serialVersionUID = 1L;

    public static final SelfProperty<TablePrimitives> SELF = PropertyFactory.createSelf(TablePrimitives.class);

    public static final NumericIdProperty<Integer> ID_PK_PROPERTY = PropertyFactory.createNumericId("ID", "TablePrimitives", Integer.class);
    public static final String ID_PK_COLUMN = "ID";

    public static final BaseProperty<Boolean> BOOLEAN_COLUMN = PropertyFactory.createBase("booleanColumn", Boolean.class);
    public static final NumericProperty<Integer> INT_COLUMN = PropertyFactory.createNumeric("intColumn", Integer.class);

    protected Boolean booleanColumn;
    protected Integer intColumn;


    public void setBooleanColumn(boolean booleanColumn) {
        beforePropertyWrite("booleanColumn", this.booleanColumn, booleanColumn);
        this.booleanColumn = booleanColumn;
    }

	public boolean isBooleanColumn() {
        beforePropertyRead("booleanColumn");
        if(this.booleanColumn == null) {
            return false;
        }
        return this.booleanColumn;
    }

    public void setIntColumn(int intColumn) {
        beforePropertyWrite("intColumn", this.intColumn, intColumn);
        this.intColumn = intColumn;
    }

    public int getIntColumn() {
        beforePropertyRead("intColumn");
        if(this.intColumn == null) {
            return 0;
        }
        return this.intColumn;
    }

    @Override
    public Object readPropertyDirectly(String propName) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch(propName) {
            case "booleanColumn":
                return this.booleanColumn;
            case "intColumn":
                return this.intColumn;
            default:
                return super.readPropertyDirectly(propName);
        }
    }

    @Override
    public void writePropertyDirectly(String propName, Object val) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch (propName) {
            case "booleanColumn":
                this.booleanColumn = (Boolean)val;
                break;
            case "intColumn":
                this.intColumn = (Integer)val;
                break;
            default:
                super.writePropertyDirectly(propName, val);
        }
    }

    private void writeObject(ObjectOutputStream out) throws IOException {
        writeSerialized(out);
    }

    private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
        readSerialized(in);
    }

    @Override
    protected void writeState(ObjectOutputStream out) throws IOException {
        super.writeState(out);
        out.writeObject(this.booleanColumn);
        out.writeObject(this.intColumn);
    }

    @Override
    protected void readState(ObjectInputStream in) throws IOException, ClassNotFoundException {
        super.readState(in);
        this.booleanColumn = (Boolean)in.readObject();
        this.intColumn = (Integer)in.readObject();
    }

}
